From d8ad9702707715a1de0975c780a0d106f0022ad1 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 27 2020 20:44:05 +0000
Subject: [PATCH 1583/2232] Extract derive implementations to module


---

diff --git a/macro/src/derive.rs b/macro/src/derive.rs
new file mode 100644
index 0000000..7a1fbdb
--- /dev/null
+++ b/macro/src/derive.rs
@@ -0,0 +1,48 @@
+use crate::syntax::{Struct, Trait};
+use proc_macro2::TokenStream;
+use quote::{quote, quote_spanned, ToTokens};
+
+pub fn expand_struct(strct: &Struct) -> TokenStream {
+    let ident = &strct.name.rust;
+    let mut expanded = TokenStream::new();
+
+    let is_copy = strct
+        .derives
+        .iter()
+        .any(|derive| derive.what == Trait::Copy);
+
+    for derive in &strct.derives {
+        match derive.what {
+            Trait::Copy => {
+                expanded.extend(quote_spanned! {derive.span=>
+                    impl ::std::marker::Copy for #ident {}
+                });
+            }
+            Trait::Clone => {
+                let body = if is_copy {
+                    quote!(*self)
+                } else {
+                    let fields = strct.fields.iter().map(|field| &field.ident);
+                    let values = strct.fields.iter().map(|field| {
+                        let ident = &field.ident;
+                        let ty = field.ty.to_token_stream();
+                        let span = ty.into_iter().last().unwrap().span();
+                        quote_spanned!(span=> &self.#ident)
+                    });
+                    quote_spanned!(derive.span=> #ident {
+                        #(#fields: ::std::clone::Clone::clone(#values),)*
+                    })
+                };
+                expanded.extend(quote_spanned! {derive.span=>
+                    impl ::std::clone::Clone for #ident {
+                        fn clone(&self) -> Self {
+                            #body
+                        }
+                    }
+                });
+            }
+        }
+    }
+
+    expanded
+}
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 4e59aad..411f87e 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1,10 +1,11 @@
+use crate::derive;
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::file::Module;
 use crate::syntax::report::Errors;
 use crate::syntax::symbol::Symbol;
 use crate::syntax::{
     self, check, mangle, Api, Enum, ExternFn, ExternType, Impl, Pair, ResolvableName, Signature,
-    Struct, Trait, Type, TypeAlias, Types,
+    Struct, Type, TypeAlias, Types,
 };
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{format_ident, quote, quote_spanned, ToTokens};
@@ -133,8 +134,9 @@ fn expand_struct(strct: &Struct) -> TokenStream {
         let vis = Token![pub](field.ident.span());
         quote!(#vis #field)
     });
+    let derived_traits = derive::expand_struct(strct);
 
-    let mut expanded = quote! {
+    quote! {
         #doc
         #[repr(C)]
         pub struct #ident {
@@ -145,46 +147,9 @@ fn expand_struct(strct: &Struct) -> TokenStream {
             type Id = #type_id;
             type Kind = ::cxx::kind::Trivial;
         }
-    };
 
-    let is_copy = strct
-        .derives
-        .iter()
-        .any(|derive| derive.what == Trait::Copy);
-    for derive in &strct.derives {
-        match derive.what {
-            Trait::Copy => {
-                expanded.extend(quote_spanned! {derive.span=>
-                    impl ::std::marker::Copy for #ident {}
-                });
-            }
-            Trait::Clone => {
-                let body = if is_copy {
-                    quote!(*self)
-                } else {
-                    let fields = strct.fields.iter().map(|field| &field.ident);
-                    let values = strct.fields.iter().map(|field| {
-                        let ident = &field.ident;
-                        let ty = field.ty.to_token_stream();
-                        let span = ty.into_iter().last().unwrap().span();
-                        quote_spanned!(span=> &self.#ident)
-                    });
-                    quote_spanned!(derive.span=> #ident {
-                        #(#fields: ::std::clone::Clone::clone(#values),)*
-                    })
-                };
-                expanded.extend(quote_spanned! {derive.span=>
-                    impl ::std::clone::Clone for #ident {
-                        fn clone(&self) -> Self {
-                            #body
-                        }
-                    }
-                });
-            }
-        }
+        #derived_traits
     }
-
-    expanded
 }
 
 fn expand_enum(enm: &Enum) -> TokenStream {
diff --git a/macro/src/lib.rs b/macro/src/lib.rs
index 6285451..1de7e6c 100644
--- a/macro/src/lib.rs
+++ b/macro/src/lib.rs
@@ -10,6 +10,7 @@
 
 extern crate proc_macro;
 
+mod derive;
 mod expand;
 mod syntax;
 mod type_id;

